clear
clc
close all
echo on
% Usamos 6 Bits para un rango de 0 a 63
% La funcin es un polinomio, ajustado mediante un nmero de puntos ingresados como ejex y ejey
% Se usa elitismo, y el miembre ELITE ocupa el lugar Gen(:,1)
% Haciendo algunos cambios como por ejemplo usar un string conjugado de N+N bits para resolver 
% un problema 2-D.
echo off
pause


%seteo y configuro
largobit=6
ejex=[0
   20
   35
   45
   64];
ejey=[0
   510
   150
   300
   0];
puntotal=size(ejex);
[P,S] = POLYFIT(ejex,ejey,puntotal(1)-1);
X=0:2^largobit;
plot(X,P(1)*X.^4 + P(2)*X.^3 + P(3)*X.^2 + P(4)*X + P(5)),xlabel('Valor de X'),ylabel('Valor de Y')
vida=100;
Gen= (RANDOM('Discrete Uniform',2,largobit,4)) - ones(largobit,4);

% vida = input('Qu cantidad de generaciones desea? : ');

GenEliteBin=Gen(:,1);
GenEliteValue=1;
temporal=zeros(vida,1);
% inicio del ciclo
for ciclo=1:vida;
 
  
% Calculo el valor en decimal de cada gen
for m=1:largobit;
   GenValue(m) = (Gen(6,m)* 1) + (Gen(5,m) * 2) + (Gen(4,m) * 4) + (Gen(3,m) * 8) + (Gen(2,m) * 16) + (Gen(1,m) * 32);
end

% Usando la funcin, encuentro el resultado para cada gen
for m=1:4;
   % Result(m) = (40*GenValue(m)) - (GenValue(m)^2);
   Result(m) = P(1)*GenValue(m)^4 + P(2)*GenValue(m)^3 + P(3)*GenValue(m)^2 + P(4)*GenValue(m) + P(5);
	if Result(m) >= GenEliteValue
   	GenEliteValue=Result(m);
		GenEliteBin = Gen(:,m);   		
   	GenElite = m;   
   else
	end 
end

% Resultado total...
Resultotal = Result(1) + Result(2) + Result(3) + Result(4); 

% Fitness de cada gen
for m=1:4;
Peso(m)= Result(m) * 1000 / Resultotal; 
end

% Reproduccin, reproducir cada string in la nueva poblacin proporcionalmente a su contrubucin en la suma
for m=1:4;
r = RANDOM('Discrete Uniform',1000,1,1);
if r <= Peso(1) 
   for i=1:6
   Gen(i,m)=Gen(i,1);
	end
elseif r <= Peso(1)+Peso(2)
   for i=1:6
   Gen(i,m)=Gen(i,2);
	end
elseif r <= Peso(1)+Peso(2)+Peso(3)
   for i=1:6
   Gen(i,m)=Gen(i,3);
	end
else 
   for i=1:6
   Gen(i,m)=Gen(i,4);
	end
end
end

%Elitismo
Gen(:,1)=GenEliteBin;

% Crossover
puntocruce1 = RANDOM('Discrete Uniform',6,1,1);
% Gen 1
% Backup
for m=1:4;
for i=1:6;
   GenBackUp(i,m)=Gen(i,m); 
end
end

%Crossover para gen 1
for i=1:6;
   if i<=puntocruce1
      Gen(i,1) = GenBackUp(i,2);
   else
   end
end

%Crossover para gen 2
for i=1:6;
   if i<=puntocruce1
      Gen(i,2) = GenBackUp(i,1);
   else
   end
end


puntocruce2 = RANDOM('Discrete Uniform',6,1,1);

%Crossover para gen 3
for i=1:6;
   if i<=puntocruce2;
      Gen(i,3) = GenBackUp(i,4);
   else
   end
end

%Crossover para gen 4
for i=1:6;
   if i<=puntocruce2;
      Gen(i,4) = GenBackUp(i,3);
   else
   end
end

% Elitismo
Gen(:,1)=GenEliteBin;

% Mutacin
 puntomutacion = RANDOM('Discrete Uniform',6,1,1);
 genmutado = RANDOM('Discrete Uniform',3,1,1);
 Gen(puntomutacion,genmutado+1)=1-Gen(puntomutacion,genmutado+1);

% fin del ciclo
%GenValue(1),GenValue(2),GenValue(3),GenValue(4) 
% verificar = input('Presione ENTER para seguir iterando');
temporal(ciclo)=GenValue(1);
end

lll=1:1:vida;
figure,plot(lll,temporal(lll)),xlabel('Generaciones'),ylabel('X Mximo Maximorum  Elite')
% figure,plot(lll,P(1)*temporal(lll).^4 + P(2)*temporal(lll).^3 + P(3)*temporal(lll).^2 + P(4)*temporal(lll) + P(5)),xlabel('Generaciones'),ylabel('Y Mximo Maximorum  Elite')
